//mariadb
import mariadb from 'mariadb';
// config
import { databaseCredentials } from '../config';
// init
const pool = mariadb.createPool({
    host: databaseCredentials.host,
    port: databaseCredentials.port,
    user: databaseCredentials.user,
    database: databaseCredentials.database,
    password: databaseCredentials.password,
    connectionLimit: 20,
});

async function getConnection() {
    let conn;
    try {
        conn = await pool.getConnection();
    } catch (err) {
        console.log(err);
        throw err;
    }
    return conn;
}

export default pool;

export { getConnection };
