// Configuration
import { webPort, webHost } from './config';

// Web server
import app from './web/express';
import activateFileServe from './web/serveFiles';

// Calendar related imports
import { refreshSyncToken } from './calendarSync/refreshSync';
import updateEvents from './calendarSync/updateEvents';

// Backend and utilities
import { connectToRedis } from './redis/init';
import { initGoogleRequestStatUp } from './requestCounter';
import updateWebhooks from './calendarSync/updateWebhooks';
import checkForNotifications from './mail/notifyBeforeAppointment';
import { initLogHandler } from './logger/logger';

initLogHandler();

initGoogleRequestStatUp();
connectToRedis();

activateFileServe();

app.listen(webPort, webHost, function () {
    console.log('Server is running on http://' + webHost + ':' + webPort);
});

setInterval(refreshSyncToken, 1000 * 2);
setInterval(updateEvents, 1000 * 1);
setInterval(updateWebhooks, 1000 * 10);
checkForNotifications();
setInterval(checkForNotifications, 1000 * 1);
refreshSyncToken();
