import { getFreeNextDays } from '../calendar/getFreeTime';
import { getServices } from '../database/services';
import { StoreID } from '../database/store';
import { UserID } from '../user/types';

async function fillCache(store_id: StoreID) {
    return new Promise(async (resolve, reject) => {
        try {
            let services = await getServices(store_id, false);

            let durationList: Number[] = [];

            let timeMeasure = new Date();

            for (const service of services) {
                for (const activity of service.activities) {
                    let serviceDuration = activity.duration;

                    if (durationList.includes(activity.duration)) continue;

                    let date = new Date();

                    let dateNextMonth = new Date();
                    dateNextMonth.setDate(1);
                    dateNextMonth.setMonth(date.getMonth() + 1);

                    try {
                        // delay 2 seconds
                        //await new Promise(resolve => setTimeout(resolve, 2000));

                        let users: UserID[] = activity.users;

                        console.log('fillCache', store_id, users, serviceDuration, date, dateNextMonth);
                        await getFreeNextDays(store_id, users, serviceDuration, date);
                        await getFreeNextDays(store_id, users, serviceDuration, dateNextMonth);
                    } catch (error) {}
                    durationList.push(activity.duration);
                }
            }

            console.log('fillCache time took (ms)', new Date().getTime() - timeMeasure.getTime());
        } catch (error) {
            console.error(error);
            reject();
        }
    });
}

export default fillCache;
