import { redis } from 'googleapis/build/src/apis/redis';
import { createClient } from 'redis';
import { REDIS_URL } from '../config';

const redisClient = createClient({
    url: REDIS_URL,
});

redisClient.on('error', (err) => console.log('Redis Client Error', err));

function connectToRedis() {
    console.log('Connecting to Redis');
    redisClient.connect();
}

process.on('SIGINT', () => {
    redisClient.disconnect();
    console.log('Disconnected from Redis due to application termination');
    process.exit(0);
});

export { connectToRedis };
export default redisClient;
