import logger from './logger/logger';

let counter = 0;
let counterTotal = 0;

interface Statistics {
    [key: string]: {
        totalCount: number;
        count: number;
        lastUpdated: Date;
    };
}

let statistics: Statistics = {};

function countGoogleRequestStatUp(type: string) {
    counter++;
    counterTotal++;
    let stat = statistics[type];

    if (!stat) stat = { totalCount: 0, count: 0, lastUpdated: new Date() };

    stat.totalCount++;
    stat.count++;
    stat.lastUpdated = new Date();

    statistics[type] = stat;
}

function initGoogleRequestStatUp() {
    setInterval(() => {
        logger.info('Google Request Statistics', JSON.stringify(statistics, null, 2));

        console.log('Google Request Statistics', statistics);
        console.log('Google Request Counter', counter);
        console.log('Google Request Total Counter', counterTotal);
        counter = 0;

        for (const type in statistics) {
            const stat = statistics[type];

            stat.count = 0;
            stat.lastUpdated = new Date();

            statistics[type] = stat;
        }
    }, 1000 * 60 * 15);

    setInterval(() => {
        console.log('Google Request Total Counter', counterTotal);
    }, 1000 * 60);
}

export { initGoogleRequestStatUp };
export default countGoogleRequestStatUp;
