import { StoreSettings } from '../database/store';
import { getUser } from '../database/user';

type UserID = string;

type isOwner = true | false;

interface User {
    user_id: UserID;
    store_id: string;
    username: string;
    isOwner: isOwner;
    settings: StoreSettings;
    lastUpdate: Date;
    session?: string;
    email?: string;
}

interface MasterUser extends User {
    isOwner: true;
}

interface WorkerUser extends User {
    isOwner: false;
}

export { UserID, User, MasterUser, WorkerUser };
